## ros-noetic-aruco-ros 3.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(aruco_ros)

find_package(OpenCV REQUIRED)

find_package(catkin REQUIRED COMPONENTS
  cv_bridge
  dynamic_reconfigure
  geometry_msgs
  image_transport
  roscpp
  rospy
  tf
  aruco
  aruco_msgs
  sensor_msgs
  visualization_msgs
)

generate_dynamic_reconfigure_options(
  cfg/ArucoThreshold.cfg
)

add_compile_options(-std=c++11)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES aruco_ros_utils
  CATKIN_DEPENDS aruco sensor_msgs tf 
)

include_directories(
  include)
include_directories(
  SYSTEM
  ${catkin_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
)
add_library(aruco_ros_utils src/aruco_ros_utils.cpp)
target_link_libraries(aruco_ros_utils ${catkin_LIBRARIES})

add_executable(single src/simple_single.cpp
                      src/aruco_ros_utils.cpp)
add_dependencies(single ${PROJECT_NAME}_gencfg)
target_link_libraries(single ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

add_executable(double src/simple_double.cpp
                      src/aruco_ros_utils.cpp)
add_dependencies(double ${PROJECT_NAME}_gencfg)
target_link_libraries(double ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

add_executable(marker_publisher src/marker_publish.cpp
                                src/aruco_ros_utils.cpp)
add_dependencies(marker_publisher ${PROJECT_NAME}_gencfg)
target_link_libraries(marker_publisher ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

#############
## Install ##
#############

install(TARGETS single double marker_publisher aruco_ros_utils
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/
   DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h"
)

foreach(dir etc launch)
    install(DIRECTORY ${dir}/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/${dir})
endforeach(dir)

=== debian/changelog ===
ros-noetic-aruco-ros (3.0.1-3buster) buster; urgency=high

  * Merge branch 'fix_camera_matrix_gallium' into 'gallium-devel'
    fix the issue with the improper camera matrix with non rectified images
    See merge request ros-overlays/aruco_ros!2
  * fix the issue with the improper camera matrix with non rectified images
  * Contributors: Sai Kishor Kothakota, saikishor

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 10 Feb 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.0.0-3buster) buster; urgency=high

  * fixes pal-robotics/aruco_ros/#89
  * Contributors: 444lhc

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 16 Jul 2021 00:00:00 -0000

ros-noetic-aruco-ros (2.1.1-3buster) buster; urgency=high

  * Use time stamps from image messages
  * Contributors: Markus Vieth

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 17 Sep 2020 00:00:00 -0000

ros-noetic-aruco-ros (2.1.0-3buster) buster; urgency=high

  * Migrate to tf2 and add utilities
  * Add support for camera extrinsics when dealing with stereo cameras
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 21 Jan 2020 00:00:00 -0000

ros-noetic-aruco-ros (2.0.2-3buster) buster; urgency=high

  * Add SYSTEM to external include dirs
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 09 Nov 2019 00:00:00 -0000

ros-noetic-aruco-ros (2.0.1-3buster) buster; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco-ros (1.0.0-3buster) buster; urgency=high

  * Merge pull request #68 <https://github.com/pal-robotics/aruco_ros//issues/68> from aPonza/ros_format
    Autoformatting as per CppStyleGuide
  * removed using namespace declarations
  * autoformatting as per CppStyleGuide
  * Merge pull request #58 <https://github.com/pal-robotics/aruco_ros//issues/58> from jrgnicho/aruco-3.0.4
    Sets the 'useRectifiedImages' member from a parameter before it uses it
  * sets the 'useRectifiedImages' member from a parameter before it uses it
  * Update readme for new coordinates
  * Fix orientation changes in aruco 3.0.0
  * Migration to aruco 3.0.4
  * Merge branch 'indigo-devel' into kinetic-devel
  * Merge pull request #41 <https://github.com/pal-robotics/aruco_ros//issues/41> from Voidminded/kinetic-devel
    Fixed OpenCV Calib3D link error on ROS Kinetic
  * Fixed OpenCV Calib3D link error on ROS Kinetic
  * Merge pull request #36 <https://github.com/pal-robotics/aruco_ros//issues/36> from pal-robotics/add-aruco-ros-utils
    Add aruco_ros_utils lib and fix some missing dependencies
  * Add aruco_ros_utils lib and fix some missing dependencies
  * Merge pull request #35 <https://github.com/pal-robotics/aruco_ros//issues/35> from ugnelis/kinetic-devel
    Removed duplicated line.
  * Removed duplicated line.
  * Merge pull request #27 <https://github.com/pal-robotics/aruco_ros//issues/27> from cehberlin/assert_fix
    Replace assert by error message to keep library functional
  * Improved camera_frame_ assert and removed unecessary opencv includes
  * Replace assert by error message to keep library functional
  * Contributors: Andrea Ponza, Bence Magyar, Christopher Hrabia, Jordi Pages, Jorge Nicho, Ugnius Malūkas, Victor Lopez, Voidminded

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco-ros (0.2.2-3buster) buster; urgency=high

  * only look for aruco if someone is looking for them
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 25 Jul 2017 00:00:00 -0000

ros-noetic-aruco-ros (0.2.1-3buster) buster; urgency=high

  * Change default threshold to match defaults of aruco marker detector
  * Add dynamic reconfigure to simple_single
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Jul 2017 00:00:00 -0000

ros-noetic-aruco-ros (0.2.0-3buster) buster; urgency=high

  * only proccesses images if there are subscribers
  * add rviz marker and add corner param
  * use double precision to improve accuracy
  * Contributors: Jordi Pages, Procópio Stein

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 19 Oct 2016 00:00:00 -0000

ros-noetic-aruco-ros (0.1.0-3buster) buster; urgency=high

  * Update changelogs and maintainer email
  * Frame parameters only checked when using camera info
  * Add marker list publisher
  * Remove unused broadcaster
  * Only do 3d when there is camera info
  * Use waitForMessage for camerainfo
  * Remove nonsense assert
  * Reorganize and allow no camera_info
  * Fix crash when distortion vector is 0 long (usb_cam)
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 10 Aug 2015 00:00:00 -0000

ros-noetic-aruco-ros (0.0.1-3buster) buster; urgency=high

  * More accurate ROS timestamps (callback triggering time)
    This commit ensures that:
    - all published msgs in a callback have the same timestamp
    - the time is as close as possible to the frame grabbing time (as fast as the marker detection may be, the delay might affect TF interpolation in an unacceptable way for applications like visual servoing)
  * Install marker_publisher executable
    This target was missing in the installation rule
  * Finished some renaming
  * changes to finish branch merge
  * aruco_ros: Fixing superfluous (and broken) linker arg to -laruco
  * Reorganize aruco_ros into 3 packages
  * Contributors: Bence Magyar, Jordi Pages, Josh Langsfeld, ObiWan, Steve Vozar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 20 May 2015 00:00:00 -0000

=== debian/control ===
Source: ros-noetic-aruco-ros
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-aruco, ros-noetic-aruco-msgs, ros-noetic-catkin, ros-noetic-cv-bridge, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-visualization-msgs
Homepage: http://www.uco.es/investiga/grupos/ava/node/26
Standards-Version: 3.9.2

Package: ros-noetic-aruco-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-aruco, ros-noetic-aruco-msgs, ros-noetic-cv-bridge, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-visualization-msgs
Description: The ARUCO Library has been developed by the Ava group of the Univeristy of Cordoba(Spain).
 It provides real-time marker based 3D pose estimation using AR markers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-aruco-ros//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-aruco-ros 3.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(aruco_ros)

find_package(OpenCV REQUIRED)

find_package(catkin REQUIRED COMPONENTS
  cv_bridge
  dynamic_reconfigure
  geometry_msgs
  image_transport
  roscpp
  rospy
  tf
  aruco
  aruco_msgs
  sensor_msgs
  visualization_msgs
)

generate_dynamic_reconfigure_options(
  cfg/ArucoThreshold.cfg
)

add_compile_options(-std=c++11)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES aruco_ros_utils
  CATKIN_DEPENDS aruco sensor_msgs tf 
)

include_directories(
  include)
include_directories(
  SYSTEM
  ${catkin_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
)
 add_library(aruco_ros_utils src/aruco_ros_utils.cpp)
 target_link_libraries(aruco_ros_utils ${catkin_LIBRARIES})

 add_executable(single src/simple_single.cpp
                       src/aruco_ros_utils.cpp)
 add_dependencies(single ${PROJECT_NAME}_gencfg)
 target_link_libraries(single ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

 add_executable(double src/simple_double.cpp
                       src/aruco_ros_utils.cpp)
 add_dependencies(double ${PROJECT_NAME}_gencfg)
 target_link_libraries(double ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

 add_executable(marker_publisher src/marker_publish.cpp
                                 src/aruco_ros_utils.cpp)
 add_dependencies(marker_publisher ${PROJECT_NAME}_gencfg ${catkin_EXPORTED_TARGETS})
 target_link_libraries(marker_publisher ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})

#############
## Install ##
#############

 install(TARGETS single double marker_publisher aruco_ros_utils
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
 )

install(DIRECTORY include/
   DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h"
)

foreach(dir etc launch)
    install(DIRECTORY ${dir}/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/${dir})
endforeach(dir)

=== debian/changelog ===
ros-noetic-aruco-ros (3.1.3-1focal) focal; urgency=high



 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Wed, 23 Nov 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.1.2-1focal) focal; urgency=high



 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Thu, 10 Nov 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.1.1-1focal) focal; urgency=high



 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Tue, 08 Nov 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.1.0-1focal) focal; urgency=high

  * Merge branch 'feat/aruco-3.1.5-migration-gallium' into 'gallium-devel'
    ArUCO 3.1.5 migration gallium
    See merge request ros-overlays/aruco_ros!5
  * Add correct fisheye distortion functionality
  * migrate to 3.1.5
  * Contributors: josegarcia, saikishor

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Mon, 07 Nov 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.0.3-1focal) focal; urgency=high

  * Merge branch 'missing_catkin_export_dep' into 'gallium-devel'
    added the missing catkin_EXPORTED_TARGETS dependency
    See merge request ros-overlays/aruco_ros!3
  * added the missing catkin_EXPORTED_TARGETS dependency
  * Contributors: Sai Kishor Kothakota, saikishor

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Mon, 16 May 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.0.2-1focal) focal; urgency=high

  * Merge pull request #103 from bmagyar/make-sai-maintainer
    Make Sai maintainer of all aruco_ros packages
  * Make Sai maintainer of all
  * Update license tags in the package.xml
  * Contributors: Bence Magyar, Sai Kishor Kothakota

 -- Sai Kishor Kothakota <sai.kishor@pal-robotics.com>  Tue, 05 Apr 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.0.1-1focal) focal; urgency=high

  * Merge branch 'fix_camera_matrix_gallium' into 'gallium-devel'
    fix the issue with the improper camera matrix with non rectified images
    See merge request ros-overlays/aruco_ros!2
  * fix the issue with the improper camera matrix with non rectified images
  * Contributors: Sai Kishor Kothakota, saikishor

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 10 Feb 2022 00:00:00 -0000

ros-noetic-aruco-ros (3.0.0-1focal) focal; urgency=high

  * fixes pal-robotics/aruco_ros/#89
  * Contributors: 444lhc

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 16 Jul 2021 00:00:00 -0000

ros-noetic-aruco-ros (2.1.1-1focal) focal; urgency=high

  * Use time stamps from image messages
  * Contributors: Markus Vieth

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 17 Sep 2020 00:00:00 -0000

ros-noetic-aruco-ros (2.1.0-1focal) focal; urgency=high

  * Migrate to tf2 and add utilities
  * Add support for camera extrinsics when dealing with stereo cameras
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 21 Jan 2020 00:00:00 -0000

ros-noetic-aruco-ros (2.0.2-1focal) focal; urgency=high

  * Add SYSTEM to external include dirs
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 09 Nov 2019 00:00:00 -0000

ros-noetic-aruco-ros (2.0.1-1focal) focal; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco-ros (1.0.0-1focal) focal; urgency=high

  * Merge pull request #68 <https://github.com/pal-robotics/aruco_ros//issues/68> from aPonza/ros_format
    Autoformatting as per CppStyleGuide
  * removed using namespace declarations
  * autoformatting as per CppStyleGuide
  * Merge pull request #58 <https://github.com/pal-robotics/aruco_ros//issues/58> from jrgnicho/aruco-3.0.4
    Sets the 'useRectifiedImages' member from a parameter before it uses it
  * sets the 'useRectifiedImages' member from a parameter before it uses it
  * Update readme for new coordinates
  * Fix orientation changes in aruco 3.0.0
  * Migration to aruco 3.0.4
  * Merge branch 'indigo-devel' into kinetic-devel
  * Merge pull request #41 <https://github.com/pal-robotics/aruco_ros//issues/41> from Voidminded/kinetic-devel
    Fixed OpenCV Calib3D link error on ROS Kinetic
  * Fixed OpenCV Calib3D link error on ROS Kinetic
  * Merge pull request #36 <https://github.com/pal-robotics/aruco_ros//issues/36> from pal-robotics/add-aruco-ros-utils
    Add aruco_ros_utils lib and fix some missing dependencies
  * Add aruco_ros_utils lib and fix some missing dependencies
  * Merge pull request #35 <https://github.com/pal-robotics/aruco_ros//issues/35> from ugnelis/kinetic-devel
    Removed duplicated line.
  * Removed duplicated line.
  * Merge pull request #27 <https://github.com/pal-robotics/aruco_ros//issues/27> from cehberlin/assert_fix
    Replace assert by error message to keep library functional
  * Improved camera_frame_ assert and removed unecessary opencv includes
  * Replace assert by error message to keep library functional
  * Contributors: Andrea Ponza, Bence Magyar, Christopher Hrabia, Jordi Pages, Jorge Nicho, Ugnius Malūkas, Victor Lopez, Voidminded

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Sep 2019 00:00:00 -0000

ros-noetic-aruco-ros (0.2.2-1focal) focal; urgency=high

  * only look for aruco if someone is looking for them
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 25 Jul 2017 00:00:00 -0000

ros-noetic-aruco-ros (0.2.1-1focal) focal; urgency=high

  * Change default threshold to match defaults of aruco marker detector
  * Add dynamic reconfigure to simple_single
  * Contributors: Victor Lopez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Jul 2017 00:00:00 -0000

ros-noetic-aruco-ros (0.2.0-1focal) focal; urgency=high

  * only proccesses images if there are subscribers
  * add rviz marker and add corner param
  * use double precision to improve accuracy
  * Contributors: Jordi Pages, Procópio Stein

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 19 Oct 2016 00:00:00 -0000

ros-noetic-aruco-ros (0.1.0-1focal) focal; urgency=high

  * Update changelogs and maintainer email


=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ros-noetic-aruco-ros
 Section: misc
 Priority: optional
-Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
+Maintainer: Sai Kishor Kothakota <sai.kishor@pal-robotics.com>
 Build-Depends: debhelper (>= 9.0.0), ros-noetic-aruco, ros-noetic-aruco-msgs, ros-noetic-catkin, ros-noetic-cv-bridge, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-visualization-msgs
 Homepage: http://www.uco.es/investiga/grupos/ava/node/26
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
